unit unSocketReader;

interface
uses Classes,Windows,Messages,IdBaseComponent, IdComponent,
     IdTCPConnection,idStackConsts,IdTCPClient,IdGlobal,sysutils;

Type
   TSocketReaderThread = class(TThread)
       protected
           procedure Execute; override;
       public
           msgHandle : HWND;  //Processing thread
           socket : TIDTcpClient;
           stop : boolean;
   end;

implementation
uses unSMSClient;

procedure TSocketReaderThread.Execute;
var
    cnt : integer;
Begin
    postMessage(msgHandle,WM_TCP_DATAAVAILABLE,0,0);
    stop := false;
    while (not stop) do begin
      try
         if not socket.Socket.Opened then
         begin
         postMessage(msgHandle,WM_TCP_SOCKET_DISCONNECTED,0,0);
            stop:=true;
         end
         else
         begin
         if socket.Socket.CheckForDataOnSource(0) then
         begin
         cnt :=    socket.Socket.InputBuffer.Size;
         postMessage(msgHandle,WM_TCP_DATAAVAILABLE,cnt,0);
         end;
         end;
      except
         postMessage(msgHandle,WM_TCP_SOCKET_DISCONNECTED,0,0);
         stop := true;
      end;
    end;
End;

end.
